#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "geometry.h"

#ifndef _WIN32
    #define stricmp strcasecmp
#endif

void generateGrid(float* &data,unsigned int* &indices,unsigned int& vertCnt,unsigned int& triCnt,int w,int h)
{
	int pos;
	data=new float[w*h*2];
	indices=new unsigned int[w*h*3];
	pos=0;
	for (int i=0;i<h;i++)
		for (int j=0;j<w;j++)
		{
			data[pos*2]=2.0* (float)j / (float)(w-1) - 1.0;
			data[pos*2+1]=2.0* (float)i / (float)(h-1) - 1.0;
			pos++;
		}
	pos=0;
	for (int i=0;i<h-1;i++)
		for (int j=0;j<w-1;j++)
		{
			indices[pos*3]=i*h+j;
			indices[pos*3+1]=i*h+j+1;
			indices[pos*3+2]=(i+1)*h+j;

			pos++;
		}

	vertCnt = h*w;
	triCnt = (h-1)*(w-1);

}

int loadBinaryData(unsigned char*& outData,const char* fname)
{
	FILE *f=fopen(fname,"rb");
	if (!f)
	{
		printf("File %s not opened!\n",fname);
		return 0;
	}
	fseek(f,0,SEEK_END);
	unsigned int nSiz=ftell(f);
	fseek(f,0,SEEK_SET);
	outData=new unsigned char[nSiz];
	fread(outData,nSiz,1,f);
	fclose(f);

	return nSiz;

}

int loadGeometryDesc(const char* name)
{
	FILE* f;

	f=fopen(name,"rt");
	if (!f)
		return 0;
	 char idname[128];
	 char datatype[32];
	int cnt;
	int siz;
	while (!feof(f))
	{
		fscanf(f,"%s count %d type %s ",idname,&cnt,datatype);
		fprintf(stderr,"%s cnt %d type %s ",idname,cnt,datatype);
		if (stricmp(idname,"index")==0)
		{
			 char mode[32];
			fscanf(f,"mode %s\n",mode);
			fprintf(stderr,"mode %s\n",mode);
		}
		else
		{
			fscanf(f,"size %d\n",&siz);
			fprintf(stderr,"size %d\n",siz);
		}
	}
	fclose(f);
	return 1;
}

int loadGeometry(SModel* pModel)
{
	pModel->vertCnt=17166;
	pModel->indexCnt=62160;

	int vposSiz=loadBinaryData(pModel->vPosArr,"geometry/vpos.dat");
	int vnormSiz=loadBinaryData(pModel->vNormalArr,"geometry/vnormal.dat");
	int vtangentSiz=loadBinaryData(pModel->vTangentArr,"geometry/tangent.dat");
	int vbinormalSiz=loadBinaryData(pModel->vBinormalArr,"geometry/binormal.dat");
	int texcoordSiz=loadBinaryData(pModel->texCoordArr,"geometry/texcoord0.dat");
	int indexSiz=loadBinaryData(pModel->indexArr,"geometry/indices.dat");

	return 1;
}
