// http://www.khronos.org/files/opengl-quick-reference-card.pdf

uniform sampler2D colorMap;
uniform sampler2D glossMap;
uniform sampler2D normalMap;

varying vec3 vLight;
varying vec3 vView;
varying vec3 vNormal;

varying mat3 TBN_mat;


void main()
{
	vec3 light=normalize(vLight);
	vec3 view=normalize(vView);
//	vec3 tsNormal=normalize(vec3(1.0,1.0,0.9)*(texture2D(normalMap, gl_TexCoord[0].xy).xyz - 0.5));//normalize(vNormal);
	vec3 tsNormal=normalize(texture2D(normalMap, gl_TexCoord[0].xy).xyz - 0.5);//normalize(vNormal);

	vec3 normal=tsNormal;
	normal=normalize(TBN_mat*normal);

	float specularLit=0.0;
	float diffuseLit=max(0.0,dot(light,normal));

	if (diffuseLit > 0.0)
	{
		vec3 lightReflect = reflect(light,normal);
		specularLit=pow(max(0.0,-dot(lightReflect,view)),16.0) * texture2D(glossMap, gl_TexCoord[0].xy).r;
	}
	
	float lit=diffuseLit+specularLit;

	gl_FragColor = lit*texture2D(colorMap, gl_TexCoord[0].xy);
}
