// http://www.khronos.org/files/opengl-quick-reference-card.pdf

uniform vec3 inLightPos;

attribute vec4 inVertPos;
attribute vec4 inTexCoord;
attribute vec3 inVertNormal;
attribute vec3 inTangent;
attribute vec3 inBinormal;

varying vec3 vLight;
varying vec3 vView;
varying vec3 vNormal;

varying mat3 TBN_mat;

void main()
{
	vec4 vPos=gl_ModelViewMatrix * inVertPos;
	gl_Position = gl_ProjectionMatrix * vPos;

	TBN_mat[0]=gl_NormalMatrix * inTangent;
	TBN_mat[1]=gl_NormalMatrix * inBinormal;
	TBN_mat[2]=gl_NormalMatrix * inVertNormal;

    vNormal = gl_NormalMatrix * inVertNormal;
	vLight = inLightPos - vPos.xyz;
	vView = -vPos.xyz;

/*
	vec3 tangent=normalize((inTangent - dot(inVertNormal,inTangent)*inVertNormal));
	vec3 binormal=cross(inVertNormal,tangent);

	mat3 TBN_mat;

	TBN_mat[0]=gl_NormalMatrix * tangent;
	TBN_mat[1]=gl_NormalMatrix * binormal;
	TBN_mat[2]=gl_NormalMatrix * inVertNormal;

	vLight = (inLightPos - vPos.xyz)*TBN_mat;
	vView = -(vPos.xyz*TBN_mat);
*/

/*
	vLight=normalize(vLight);
	vView=normalize(vView);
	vec3 vLightReflect = -reflect(vLight,vNormal);

	float specularLit=max(0,pow(dot(vLightReflect,vView),4));
	float diffuseLit=max(0,dot(vLight,vNormal));

	float lit=specularLit+diffuseLit;
	gl_FrontColor=vec4(lit,lit,lit,1.0);//vNormal.zzzz;//gl_Color;
*/
	gl_TexCoord[0]=inTexCoord;

}
